; #########################################################################

      .386
      .model flat, stdcall  ; 32 bit memory model
      option casemap :none  ; case sensitive

      include COM.inc     ; local includes for this file

      ;include \masm32\include\Objects.inc
      
      
; #########################################################################

.code

start:
      invoke GetModuleHandle, NULL
      mov hInstance, eax

      invoke GetCommandLine
      mov CommandLine, eax

      invoke WinMain,hInstance,NULL,CommandLine,SW_SHOWDEFAULT
      invoke ExitProcess,eax

; #########################################################################

WinMain proc hInst     :DWORD,
             hPrevInst :DWORD,
             CmdLine   :DWORD,
             CmdShow   :DWORD

      ;====================
      ; Put LOCALs on stack
      ;====================

      LOCAL wc   :WNDCLASSEX
      LOCAL msg  :MSG
      LOCAL Wwd  :DWORD
      LOCAL Wht  :DWORD
      LOCAL Wtx  :DWORD
      LOCAL Wty  :DWORD

      ;==================================================
      ; Fill WNDCLASSEX structure with required variables
      ;==================================================

      invoke LoadIcon,hInst,500    ; icon ID
      mov hIcon, eax

      szText szClassName,"Project_Class"

      mov wc.cbSize,         sizeof WNDCLASSEX
      mov wc.style,          CS_BYTEALIGNWINDOW ;or CS_HREDRAW or CS_VREDRAW 
                             
      mov wc.lpfnWndProc,    offset WndProc
      mov wc.cbClsExtra,     NULL
      mov wc.cbWndExtra,     NULL
      m2m wc.hInstance,      hInst
      mov wc.hbrBackground,  COLOR_WINDOW+1
      mov wc.lpszMenuName,   NULL
      mov wc.lpszClassName,  offset szClassName
      m2m wc.hIcon,          hIcon
        invoke LoadCursor,NULL,IDC_ARROW
      mov wc.hCursor,        eax
      m2m wc.hIconSm,        hIcon

      invoke RegisterClassEx, ADDR wc

      ;================================
      ; Centre window at following size
      ;================================

      mov Wwd, 500
      mov Wht, 350

      invoke GetSystemMetrics,SM_CXSCREEN
      invoke TopXY,Wwd,eax
      mov Wtx, eax

      invoke GetSystemMetrics,SM_CYSCREEN
      invoke TopXY,Wht,eax
      mov Wty, eax

      invoke CreateWindowEx,WS_EX_LEFT,
                            ADDR szClassName,
                            ADDR szDisplayName,
                            WS_OVERLAPPEDWINDOW,
                            Wtx,Wty,Wwd,Wht,
                            NULL,NULL,
                            hInst,NULL
      mov   hWnd,eax

      invoke LoadMenu,hInst,600  ; menu ID
      invoke SetMenu,hWnd,eax

      invoke ShowWindow,hWnd,SW_SHOWNORMAL
      invoke UpdateWindow,hWnd

      ;===================================
      ; Loop until PostQuitMessage is sent
      ;===================================

    StartLoop:
      invoke GetMessage,ADDR msg,NULL,0,0
      cmp eax, 0
      je ExitLoop
      invoke TranslateMessage, ADDR msg
      invoke DispatchMessage,  ADDR msg
      jmp StartLoop
    ExitLoop:

      return msg.wParam

WinMain endp

; #########################################################################

WndProc proc hWin   :DWORD,
             uMsg   :DWORD,
             wParam :DWORD,
             lParam :DWORD

    LOCAL var    :DWORD
    LOCAL caW    :DWORD
    LOCAL caH    :DWORD
    LOCAL Rct    :RECT
    LOCAL hDC    :DWORD
    LOCAL Ps     :PAINTSTRUCT
    LOCAL buffer1[128]:BYTE  ; these are two spare buffers
    LOCAL buffer2[128]:BYTE  ; for text manipulation etc..

    .if uMsg == WM_COMMAND
    ;======== menu commands ========
        .if wParam == 1010
            invoke SendMessage,hWin,WM_SYSCOMMAND,SC_CLOSE,NULL
        .elseif wParam == 1900
            szText AboutMsg,"The MASM32 OOP Model Hard at work!",13,10,\
            "Copyright  Prostart 1999"
            invoke ShellAbout,hWin,ADDR szDisplayName,ADDR AboutMsg,hIcon
        .endif
    ;====== end menu commands ======

    .elseif uMsg == WM_CREATE
    
       ; Create JPicture Objects...
       mov hPicture1, $NEW( JPicture, SADD("homer-st.jpg"), NULL, NULL)
       mov hPicture2, $NEW( JPicture, SADD("zireaska.gif"), 100,  NULL)
       mov hPicture3, $NEW( JPicture, SADD("NaN.bmp"),      200,  NULL)

       ; Create a Painter Object to take care of paint methods...
       ; Painter inherits from Linked List (generic class)
       mov hPainter, $NEW( Painter, TRUE ) ; TRUE = DESTROY OBJECTS IN LIST IF DESTROYED
       
       ; add objects to the painter..
       METHOD hPainter, Painter, addNode, hPicture1
       METHOD hPainter, Painter, addNode, hPicture2
       METHOD hPainter, Painter, addNode, hPicture3
       
       ; Set system variabls to NULL (clicks)
       mov cClicked1, FALSE
       mov cClicked2, FALSE
       mov cClicked3, FALSE
     
     ; Do back buffering setup.. create DC, bitmap, and brush..         
     INVOKE GetDC,hWin
	mov hDC,eax
     INVOKE CreateCompatibleDC, hDC
	mov hDC2,eax
	invoke GetClientRect, hWin, addr Rct
     INVOKE CreateCompatibleBitmap,hDC,Rct.right,Rct.bottom
	mov hBit,eax
     INVOKE SelectObject,hDC2,hBit
	mov oldbit,eax
     INVOKE CreateSolidBrush,00FFFFFFh
     mov hBr, eax
     INVOKE FillRect, hDC2, ADDR Rct, eax
     invoke ReleaseDC, hWin, hDC
	

    .elseif uMsg == WM_SIZE
    
     ; If window resizes, rebuild a new DC bitmap...    
     INVOKE GetDC,hWin
     mov hDC,eax
     invoke GetClientRect, hWin, addr Rct    
     INVOKE CreateCompatibleBitmap,hDC,Rct.right,Rct.bottom
     INVOKE SelectObject,hDC2,eax
     invoke DeleteObject, eax
     invoke ReleaseDC, hWin, hDC
    

    .elseif uMsg==WM_MOUSEMOVE

          ; Specific function defined in JPicture only!
          ; It extends CPicture specifically to handle mouse events..
          ; as CPicture doesn't have this...
    
          .if( cClicked1 == TRUE )
             METHOD hPicture1, JPicture, CenterOnMouse, lParam
          .endif

          .if( cClicked2 == TRUE )
             METHOD hPicture2, JPicture, CenterOnMouse, lParam
          .endif

          .if( cClicked3 == TRUE )
             METHOD hPicture3, JPicture, CenterOnMouse, lParam
          .endif
          .if( cClicked3 == TRUE) || (cClicked2 == TRUE) || (cClicked1 == TRUE )
             invoke InvalidateRect,hWin,NULL,FALSE
          .endif


    .elseif uMsg==WM_LBUTTONDOWN 

          ; Again JPicture specific function.. to extend CPicture for
          ; mouse specific events..
          
          .if( $EAX( hPicture1, JPicture, IsClicked, lParam ) == TRUE )
            xor cClicked1, TRUE
          .endif

          .if( $EAX( hPicture2, JPicture, IsClicked, lParam ) == TRUE )
            xor cClicked2, TRUE
          .endif

          .if( $EAX( hPicture3, JPicture, IsClicked, lParam ) == TRUE )
            xor cClicked3, TRUE
          .endif
          
          

    .elseif uMsg == WM_PAINT
          
          ; Clear the drawing sruface of the back buffer..
          invoke GetClientRect, hWin, addr Rct
          INVOKE FillRect, hDC2, ADDR Rct, hBr

          ; Draw all objects in the Painter list..
          METHOD hPainter, Painter, PaintAll, hWin, hDC2
           
        invoke BeginPaint,hWin,ADDR Ps
          mov hDC, eax
          
          ; Copy the back buffer to the proper hDC
          INVOKE BitBlt,hDC, 0, 0, Rct.right,Rct.bottom, hDC2, 0, 0, SRCCOPY
          
        invoke EndPaint,hWin,ADDR Ps
        return 0

    .elseif uMsg == WM_DESTROY
        ; Destroy all objects created..
        
        ; Since i created the Painter object with TRUE in its option,
        ; it will parse all objects in its list and destroy them as wel
    
        DESTROY hPainter

        ; Clean up back buffer stuff...
        INVOKE SelectObject,hDC2,oldbit
        INVOKE DeleteDC, hDC2
        INVOKE DeleteObject,hBit
        invoke DeleteObject, hBr
        
        invoke PostQuitMessage,NULL
        return 0 
    .endif

    invoke DefWindowProc,hWin,uMsg,wParam,lParam

    ret

WndProc endp

; ########################################################################

TopXY proc wDim:DWORD, sDim:DWORD

    shr sDim, 1      ; divide screen dimension by 2
    shr wDim, 1      ; divide window dimension by 2
    mov eax, wDim    ; copy window dimension into eax
    sub sDim, eax    ; sub half win dimension from half screen dimension

    return sDim

TopXY endp

end start
