ifndef _CPicture_
_CPicture_ equ 1

include CPaint.asm  ; Inherits from CPaint!!!

sIID_IPicture       TEXTEQU <{07BF80980H, 0BF32H, 0101AH,   \
                             {08BH, 0BBH, 000H, 0AAH, 000H, 030H, 00CH, 0ABH}}>


_vtIPicture MACRO CastName:REQ
    ; IUnknown methods 
    _vtIUnknown CastName
    ; IPicture methods
    &CastName&_get_Handle              comethod2 ?
    &CastName&_get_hPal                comethod2 ?
    &CastName&_get_Type                comethod2 ?
    &CastName&_get_Width               comethod2 ?
    &CastName&_get_Height              comethod2 ?
    &CastName&_Render                  comethod11 ?	
    &CastName&_set_hPal                comethod2 ?
    &CastName&_get_CurDC               comethod2 ?
    &CastName&_SelectPicture           comethod4 ?
    &CastName&_get_KeepOriginalFormat  comethod2 ?
    &CastName&_put_KeepOriginalFormat  comethod2 ?
    &CastName&_PictureChanged          comethod1 ?
    &CastName&_SaveAsFile              comethod4 ?
    &CastName&_get_Attributes          comethod2 ?
ENDM

IPicture              STRUCT
    _vtIPicture IPicture
IPicture              ENDS


; --=====================================================================================--
; CPicture CLASS
; --=====================================================================================--
; Built by NaN's Object Class Creator
;  Sept 1, 2001
;
; By NaN ( jaymeson@hotmail.com )
; http://nan32asm.cjb.net
;
; --=====================================================================================--
; CLASS METHOD PROTOS
; --=====================================================================================--
   CPicture_Init    PROTO  :DWORD, :DWORD, :DWORD, :DWORD

; --=====================================================================================--
; FUNCTION POINTER PROTOS
; --=====================================================================================--
   CPic_destructorPto    TYPEDEF  PROTO  :DWORD 
   CPic_getHeightPto    TYPEDEF  PROTO  :DWORD
   CPic_getWidthPto    TYPEDEF  PROTO  :DWORD
   CPic_getxPosPto    TYPEDEF  PROTO  :DWORD
   CPic_getyPosPto    TYPEDEF  PROTO  :DWORD
   CPic_setxPosPto    TYPEDEF  PROTO  :DWORD, :DWORD
   CPic_setyPosPto    TYPEDEF  PROTO  :DWORD, :DWORD
   
; --=====================================================================================--
; CLASS STRUCTURE
; --=====================================================================================--
   
   CLASS CPicture, CPic
      CPaint <>
      CMETHOD getHeight  ; Method: get the value of Height in eax
      CMETHOD getWidth   ; Method: get the value of Width in eax
      CMETHOD getxPos    ; Method: get the value of xPos in eax
      CMETHOD getyPos    ; Method: get the value of yPos in eax
      CMETHOD setxPos    ; Method: set the value of xPos
      CMETHOD setyPos    ; Method: set the value of yPos
      Height  dd ?
      hPicture     dd    ?
      AWidth     dd    ?
      xPos     dd    ?
      yPos     dd    ?
      pWidth   dw    ?
      pHeight  dw    ?
   CPicture ENDS

.data
   BEGIN_INIT 
      dd offset CPic_destructor_Funct
      dd offset CPic_getHeight_Funct
      dd offset CPic_getWidth_Funct
      dd offset CPic_getxPos_Funct
      dd offset CPic_getyPos_Funct
      dd offset CPic_setxPos_Funct
      dd offset CPic_setyPos_Funct
      dd NULL
      dd NULL
      dd NULL
      dd NULL
      dd NULL
      dw NULL
      dw NULL
   END_INIT
   
   
IID_IPicture    DWORD 07bf80980h  ;unsigned long.
                                WORD  0bf32h ;unsigned short.
                                WORD  0101ah ;unsigned short
                                BYTE 08bh,0bbh,0,0aah,0,030h,0ch,0abh
   

.code
; --=====================================================================================--
; CLASS CONSTRUCTOR
; --=====================================================================================--
CPicture_Init  PROC uses edi esi lpTHIS:DWORD, pszFile:DWORD, xStart:DWORD, yStart:DWORD
   
    LOCAL hFile:DWORD, pvData:DWORD,     dwBytesRead:DWORD
    LOCAL pstm:DWORD,  dwFileSize:DWORD, hGlobal:DWORD
    LOCAL ghWnd:DWORD, bRead:DWORD

   SET_CLASS CPicture INHERITS INTERFACE CPaint  ; Initialize the Object to inherit...
   
   SetObject edi, CPicture
   OVERRIDE Paint, CPic_Paint_Funct  ; Do Polymorphic Action...


     ;ppPicture:DWORD
    ; This function loads a file into an IStream.
    ; open file

    invoke CreateFile, pszFile, GENERIC_READ, 0, NULL, OPEN_EXISTING, 0, NULL
    mov hFile, eax
    .IF hFile == INVALID_HANDLE_VALUE        ; we had an error
        jmp @Err
    .ENDIF

    ; get file size
    invoke GetFileSize, hFile, NULL
    mov dwFileSize, eax
    .IF dwFileSize == -1        ; we had an error
        invoke CloseHandle, hFile
        jmp @Err
    .ENDIF

    mov pvData, NULL
    ; alloc memory based on file size
    invoke GlobalAlloc, GMEM_MOVEABLE, dwFileSize
    mov hGlobal, eax
    .IF !hGlobal        ; we had an error
        invoke CloseHandle, hFile
        jmp @Err
    .ENDIF

    invoke GlobalLock, hGlobal
    mov pvData , eax
    .IF !pvData        ; we had an error
        jmp @Err
    .ENDIF

    mov dwBytesRead, NULL
    ; read file and store in global memory
    invoke ReadFile, hFile, pvData, dwFileSize, ADDR dwBytesRead, NULL
    mov bRead, eax
    .IF bRead == FALSE        ; we had an error
        jmp @Err
    .ENDIF

    invoke GlobalUnlock, hGlobal
    invoke CloseHandle, hFile

    mov pstm, NULL
    ; create IStream* from global memory
    invoke CreateStreamOnHGlobal, hGlobal, TRUE, ADDR pstm
    .IF_FAILED
        jmp @Err
    .ENDIF

    .IF !pstm
        jmp @Err
    .ENDIF

        ; Create IPicture from image file

        mov ecx, [edi].hPicture

        invoke OleLoadPicture, pstm, dwFileSize, FALSE, ADDR IID_IPicture, addr [edi].hPicture
        .IF_FAILED
            coinvoke pstm, IUnknown, Release
            jmp @Err
        .ENDIF

    coinvoke pstm, IUnknown, Release

    
    ; For speed lets get picture stuff now..
    coinvoke [edi].hPicture, IPicture, get_Width, addr [edi].AWidth
    coinvoke [edi].hPicture, IPicture, get_Height, addr [edi].Height
    
    mov eax, xStart
    mov [edi].xPos, eax
    mov eax, yStart
    mov [edi].yPos, eax

   jmp @F
   @Err:
     invoke Beep, NULL, NULL
     mov [edi].hPicture, NULL
   @@:

   ReleaseObject edi
   ret
CPicture_Init ENDP

; --=====================================================================================--
; destructor METHOD BEHAVIOR
; --=====================================================================================--
CPic_destructor_Funct  PROC uses edi lpTHIS:DWORD 
   SetObject edi, CPicture

   .if [edi].hPicture
       coinvoke [edi].hPicture, IUnknown, Release
   .endif

   ReleaseObject edi
   ret
CPic_destructor_Funct  ENDP

; --=====================================================================================--
; getHeight METHOD BEHAVIOR
; --=====================================================================================--
CPic_getHeight_Funct  PROC uses edi lpTHIS:DWORD
   SetObject edi, CPicture

   mov eax, [edi].Height

   ReleaseObject edi
   ret
CPic_getHeight_Funct  ENDP

; --=====================================================================================--
; getWidth METHOD BEHAVIOR
; --=====================================================================================--
CPic_getWidth_Funct  PROC uses edi lpTHIS:DWORD
   SetObject edi, CPicture

   mov eax, [edi].AWidth

   ReleaseObject edi
   ret
CPic_getWidth_Funct  ENDP

; --=====================================================================================--
; getxPos METHOD BEHAVIOR
; --=====================================================================================--
CPic_getxPos_Funct  PROC uses edi lpTHIS:DWORD
   SetObject edi, CPicture

   mov eax, [edi].xPos

   ReleaseObject edi
   ret
CPic_getxPos_Funct  ENDP

; --=====================================================================================--
; getyPos METHOD BEHAVIOR
; --=====================================================================================--
CPic_getyPos_Funct  PROC uses edi lpTHIS:DWORD
   SetObject edi, CPicture

   mov eax, [edi].yPos

   ReleaseObject edi
   ret
CPic_getyPos_Funct  ENDP

; --=====================================================================================--
; setxPos METHOD BEHAVIOR
; --=====================================================================================--
CPic_setxPos_Funct  PROC uses edi lpTHIS:DWORD, DATA:DWORD
   SetObject edi, CPicture

   mov eax, DATA
   mov [edi].xPos, eax

   ReleaseObject edi
   ret
CPic_setxPos_Funct  ENDP

; --=====================================================================================--
; setyPos METHOD BEHAVIOR
; --=====================================================================================--
CPic_setyPos_Funct  PROC uses edi lpTHIS:DWORD, DATA:DWORD
   SetObject edi, CPicture

   mov eax, DATA
   mov [edi].yPos, eax

   ReleaseObject edi
   ret
CPic_setyPos_Funct  ENDP

; --=====================================================================================--
; Paint METHOD BEHAVIOR
; --=====================================================================================--
CPic_Paint_Funct  PROC uses edi lpTHIS:DWORD, hWnd:DWORD, hdc:DWORD
   LOCAL rect:RECT
   LOCAL nWidth:DWORD,      nHeight:DWORD,  neghmHeight:DWORD
   
   SetObject edi, CPicture
   
        .IF [edi].hPicture
  
            ; convert himetric to pixels
            invoke GetDeviceCaps, hdc, LOGPIXELSX
            invoke MulDiv, [edi].AWidth, eax, 2540
            mov nWidth, eax
            mov [edi].pWidth, ax
            
            invoke GetDeviceCaps,hdc, LOGPIXELSY
            invoke MulDiv, [edi].Height, eax, 2540
            mov nHeight, eax
            mov [edi].pHeight, ax
            
            xor eax, eax
            sub eax, [edi].Height
            mov neghmHeight, eax
        
            invoke GetClientRect, hWnd, ADDR rect
            ; display picture using IPicture::Render
            coinvoke [edi].hPicture, IPicture, Render, hdc, [edi].xPos, [edi].yPos, nWidth, nHeight, 0, [edi].Height, [edi].AWidth, neghmHeight, ADDR rect
  
        .ENDIF

   ReleaseObject edi
   ret
CPic_Paint_Funct  ENDP

endif