ifndef _LNKLST_
_LNKLST_ equ 1

include LINK.asm                             ; uses reference to LINK.asm (not inheritance)

; --=====================================================================================--
; LNKLST CLASS
; --=====================================================================================--
; Built by NaN's Object Class Creator
;  Sept 1, 2001
;
; By NaN ( jaymeson@hotmail.com )
; http://nan32asm.cjb.net
;
; --=====================================================================================--
; CLASS METHOD PROTOS
; --=====================================================================================--
   LNKLST_Init    PROTO  :DWORD, :DWORD

; --=====================================================================================--
; FUNCTION POINTER PROTOS
; --=====================================================================================--
   LNKL_destructorPto    TYPEDEF  PROTO  :DWORD 
   LNKL_addNodePto    TYPEDEF  PROTO  :DWORD, :DWORD
   LNKL_deleteNodePto    TYPEDEF  PROTO  :DWORD, :DWORD
   LNKL_getCURLNKPto    TYPEDEF  PROTO  :DWORD
   LNKL_getlpHeadPto    TYPEDEF  PROTO  :DWORD
   LNKL_getlpTailPto    TYPEDEF  PROTO  :DWORD
   LNKL_getNextNodePto    TYPEDEF  PROTO  :DWORD
   LNKL_getNodePto    TYPEDEF  PROTO  :DWORD
   LNKL_getNodeCountPto   TYPEDEF  PROTO  :DWORD
   LNKL_getPrevNodePto    TYPEDEF  PROTO  :DWORD
   LNKL_setCURLNKPto    TYPEDEF  PROTO  :DWORD, :DWORD
   LNKL_setlpHeadPto    TYPEDEF  PROTO  :DWORD, :DWORD
   LNKL_setlpTailPto    TYPEDEF  PROTO  :DWORD, :DWORD

; --=====================================================================================--
; CLASS STRUCTURE
; --=====================================================================================--
   CLASS LNKLST, LNKL
      CMETHOD destructor       ; MUST BE THE FIRST, OR OBJECTS.INC WILL FAIL
      CMETHOD addNode          ; Add a new link
      CMETHOD deleteNode       ; Remove a link
      CMETHOD getCURLNK        ; Method: get the value of CURLNK in eax *
      CMETHOD getlpHead        ; Method: get the value of lpHead in eax
      CMETHOD getlpTail        ; Method: get the value of lpTail in eax
      CMETHOD getNextNode      ; 
      CMETHOD getNode          ; 
      CMETHOD getNodeCount     ; Method
      CMETHOD getPrevNode      ; 
      CMETHOD setCURLNK        ; Method: set the value of CURLNK *
      CMETHOD setlpHead        ; Method: set the value of lpHead *
      CMETHOD setlpTail        ; Method: set the value of lpTail *
      CURLNK     dd    ?
      lpHead     dd    ?
      lpTail     dd    ?
      NodeCount  dd    ?
      CleanAll   dd    ?      
   LNKLST ENDS

.data
   
   BEGIN_INIT
      dd offset LNKL_destructor_Funct
      dd offset LNKL_addNode_Funct
      dd offset LNKL_deleteNode_Funct
      dd offset LNKL_getCURLNK_Funct
      dd offset LNKL_getlpHead_Funct
      dd offset LNKL_getlpTail_Funct
      dd offset LNKL_getNextNode_Funct
      dd offset LNKL_getNode_Funct
      dd offset LNKL_getNodeCount_Funct      
      dd offset LNKL_getPrevNode_Funct
      dd offset LNKL_setCURLNK_Funct
      dd offset LNKL_setlpHead_Funct
      dd offset LNKL_setlpTail_Funct
      dd NULL
      dd NULL
      dd NULL
      dd NULL
      dd NULL      
   END_INIT


.code
; --=====================================================================================--
; CLASS CONSTRUCTOR
; --=====================================================================================--
LNKLST_Init  PROC uses edi esi lpTHIS:DWORD, Opt:DWORD
   SET_CLASS LNKLST
   SetObject edi, LNKLST

     mov eax, Opt
     mov [edi].CleanAll, eax

   ReleaseObject edi
   ret
LNKLST_Init ENDP

; --=====================================================================================--
; destructor METHOD BEHAVIOR
; --=====================================================================================--
LNKL_destructor_Funct  PROC uses edi lpTHIS:DWORD 
   LOCAL HEADPTR :DWORD
   LOCAL NEXT    :DWORD
   LOCAL TEMP    :DWORD

   SetObject edi, LNKLST
   
   ; Get the Head Pointer
   mov HEADPTR, $EAX( edi, LNKLST, getlpHead )
   @@:
     mov eax, HEADPTR
     
     cmp eax, NULL                                ;Test the link for NULL
     je  DoneDestroy
     
     mov NEXT, $EAX( eax, LINK, getNext )         ; eax points to a LINK object.
                                                  ; So, get the next link, and then 
                                                  ; destroy it.

     mov TEMP, $DESTROY( HEADPTR )                ; This is the returned lpData Object 
                                                  ; (Written in LINK Destructor)
     .if( [edi].CleanAll == TRUE )
        DESTROY TEMP                              ; Destroy it as well, if instructed
     .endif
     
     mov eax, NEXT                                ; Test the next link for null
     mov HEADPTR, eax
     jmp @B

   ; All done!
   DoneDestroy:

   ReleaseObject edi
   ret
LNKL_destructor_Funct  ENDP

; --=====================================================================================--
; getCURLNK METHOD BEHAVIOR
; --=====================================================================================--
LNKL_getCURLNK_Funct  PROC uses edi lpTHIS:DWORD
   SetObject edi, LNKLST

   mov eax, [edi].CURLNK

   ReleaseObject edi
   ret
LNKL_getCURLNK_Funct  ENDP

; --=====================================================================================--
; getlpHead METHOD BEHAVIOR
; --=====================================================================================--
LNKL_getlpHead_Funct  PROC uses edi lpTHIS:DWORD
   SetObject edi, LNKLST

   mov eax, [edi].lpHead

   ReleaseObject edi
   ret
LNKL_getlpHead_Funct  ENDP

; --=====================================================================================--
; getlpTail METHOD BEHAVIOR
; --=====================================================================================--
LNKL_getlpTail_Funct  PROC uses edi lpTHIS:DWORD
   SetObject edi, LNKLST

   mov eax, [edi].lpTail

   ReleaseObject edi
   ret
LNKL_getlpTail_Funct  ENDP

; --=====================================================================================--
; setCURLNK METHOD BEHAVIOR
; --=====================================================================================--
LNKL_setCURLNK_Funct  PROC uses edi lpTHIS:DWORD, DATA:DWORD
   SetObject edi, LNKLST

   mov eax, DATA
   mov [edi].CURLNK, eax

   ReleaseObject edi
   ret
LNKL_setCURLNK_Funct  ENDP

; --=====================================================================================--
; setlpHead METHOD BEHAVIOR
; --=====================================================================================--
LNKL_setlpHead_Funct  PROC uses edi lpTHIS:DWORD, DATA:DWORD
   SetObject edi, LNKLST

   mov eax, DATA
   mov [edi].lpHead, eax

   ReleaseObject edi
   ret
LNKL_setlpHead_Funct  ENDP

; --=====================================================================================--
; setlpTail METHOD BEHAVIOR
; --=====================================================================================--
LNKL_setlpTail_Funct  PROC uses edi lpTHIS:DWORD, DATA:DWORD
   SetObject edi, LNKLST

   mov eax, DATA
   mov [edi].lpTail, eax

   ReleaseObject edi
   ret
LNKL_setlpTail_Funct  ENDP

; --=====================================================================================--
; addNode METHOD BEHAVIOR
; --=====================================================================================--
LNKL_addNode_Funct  PROC uses edi lpTHIS:DWORD, lpDATA:DWORD
   LOCAL TEMP    :DWORD
   LOCAL HEADPTR :DWORD
   LOCAL TAILPTR :DWORD

   SetObject edi, LNKLST
   
   mov TEMP, $NEW( LINK )                              ; Create a New LINK node.
   METHOD edi, LNKLST, setCURLNK, eax                  ; Set the CURRENT LINK
   METHOD TEMP, LINK, setData, lpDATA                  ; Set the new link's data pointer
   mov HEADPTR, $EAX( edi, LNKLST, getlpHead )         ; Get the head pointer
   
   cmp eax, NULL
   jne CASE2
     ; yes, CASE1
     ; Set the head and tail pointers of this instance
     METHOD lpTHIS, LNKLST, setlpHead, TEMP
     METHOD lpTHIS, LNKLST, setlpTail, TEMP
     
     ; Next and Prev of LINK is set to NULL from creation
     jmp ExitAdd

   CASE2:
     ; Head pointer is not NULL, add to the tail the new link
     ; Get the current tail pointer
     mov TAILPTR, $EAX( edi, LNKLST, getlpTail )
     
     ; Set the current tail link's next field to the new link
     METHOD TAILPTR, LINK, setNext, TEMP
     
     ; Set the new link's prev to the curent tail
     METHOD TEMP, LINK, setPrev, TAILPTR
     
     ; Leave the new Link's Next at null
     
     ; set the LNKLST's tail pointer to the new link
     METHOD edi, LNKLST, setlpTail, TEMP
     
   ExitAdd:

     ; Increment The Node Count...
     inc [edi].NodeCount

   ReleaseObject edi
   ret
LNKL_addNode_Funct  ENDP

; --=====================================================================================--
; deleteNode METHOD BEHAVIOR
; --=====================================================================================--
LNKL_deleteNode_Funct  PROC uses edi lpTHIS:DWORD, KILLIT:DWORD
   LOCAL TEMP :DWORD
   LOCAL HEADPTR :DWORD
   LOCAL TAILPTR :DWORD

   SetObject edi, LNKLST
     
   mov TEMP, $EAX( edi, LNKLST, getCURLNK )
   cmp eax, NULL
   je LErr
     
     mov HEADPTR, $EAX( TEMP, LINK, getPrev )               ; Get the prev link and set
     mov TAILPTR, $EAX( TEMP, LINK, getNext )               ; Get the next link
     
     ; Adjust the link list befor deleting the link
     mov edx, TAILPTR
     mov ecx, HEADPTR
     .if ( ( ecx != NULL ) && ( edx != NULL ) )
       ; Not on an end point
       METHOD HEADPTR, LINK, setNext, TAILPTR
       METHOD TAILPTR, LINK, setPrev, HEADPTR
       METHOD lpTHIS, LNKLST, setCURLNK, HEADPTR
     
     .elseif ( ( ecx == NULL) && ( edx == NULL ) )
       ; Both NULL, set the head, tail and CURLNK...
       METHOD lpTHIS, LNKLST, setlpHead, NULL
       METHOD lpTHIS, LNKLST, setlpTail, NULL
       METHOD lpTHIS, LNKLST, setCURLNK, NULL
     
     .elseif ( ecx == NULL )
       ; Previous is NULL, then at first position
       METHOD lpTHIS, LNKLST, setlpHead, TAILPTR
       METHOD TAILPTR, LINK, setPrev, NULL
       METHOD lpTHIS, LNKLST, setCURLNK, TAILPTR
     
     .elseif ( edx == NULL )
       ; Next is null, then at the end of the list
       METHOD lpTHIS, LNKLST, setlpTail, HEADPTR
       METHOD HEADPTR, LINK, setNext, NULL
       METHOD lpTHIS, LNKLST, setCURLNK, HEADPTR
     .endif
     
     ; Delete the link
     mov TEMP, $DESTROY( TEMP )
     
     ; Optional destory the info object as well
     .if (KILLIT == TRUE)
       DESTROY TEMP
     .endif
     
     ; Decrement Node Count..
     dec [edi].NodeCount
     
     ; Jump over Err's
     jmp @F

   LErr:
   ; Error, return NULL
   mov eax, NULL
   @@:

   ReleaseObject edi
   ret
LNKL_deleteNode_Funct  ENDP

; --=====================================================================================--
; getNextNode METHOD BEHAVIOR
; --=====================================================================================--
LNKL_getNextNode_Funct  PROC uses edi lpTHIS:DWORD
   LOCAL TEMP :DWORD

   SetObject edi, LNKLST
   
   cmp $EAX( edi, LNKLST, getCURLNK), NULL
   je @F
   cmp $EAX( eax, LINK, getNext), NULL
   je @F
     mov TEMP, eax
     METHOD edi, LNKLST, setCURLNK, TEMP
     METHOD TEMP, LINK, getData
   @@:

   ReleaseObject edi
   ret
LNKL_getNextNode_Funct  ENDP

; --=====================================================================================--
; getNode METHOD BEHAVIOR
; --=====================================================================================--
LNKL_getNode_Funct  PROC uses edi lpTHIS:DWORD
   LOCAL TEMP :DWORD
   
   SetObject edi, LNKLST
   
   cmp $EAX( edi, LNKLST, getCURLNK), NULL
   je @F
     mov TEMP, eax
     METHOD TEMP, LINK, getData
   @@:

   ReleaseObject edi
   ret
LNKL_getNode_Funct  ENDP

; --=====================================================================================--
; getPrevNode METHOD BEHAVIOR
; --=====================================================================================--
LNKL_getPrevNode_Funct  PROC uses edi lpTHIS:DWORD
   LOCAL TEMP :DWORD
   
   SetObject edi, LNKLST   
   cmp $EAX( edi, LNKLST, getCURLNK), NULL
   je @F
   cmp $EAX( eax, LINK, getPrev), NULL
   je @F
     mov TEMP, eax
     METHOD edi, LNKLST, setCURLNK, TEMP
     METHOD TEMP, LINK, getData
   @@:

   ReleaseObject edi
   ret
LNKL_getPrevNode_Funct  ENDP

; --=====================================================================================--
; getNodeCount METHOD BEHAVIOR
; --=====================================================================================--
LNKL_getNodeCount_Funct  PROC uses edi lpTHIS:DWORD
   SetObject edi, LNKLST

     mov eax, [edi].NodeCount
   
   ReleaseObject edi
   ret
LNKL_getNodeCount_Funct  ENDP

endif